/* gcc -o x_has_compositor x_has_compositor.c -lX11 */
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

int has_compositor(Display *dpy, int screen) {
    char prop_name[64];
    snprintf(prop_name, sizeof prop_name, "_NET_WM_CM_S%d", screen);
    Atom prop_atom = XInternAtom(dpy, prop_name, False);
    return XGetSelectionOwner(dpy, prop_atom) != None;
}

int main(void) {
    Display *dpy = XOpenDisplay(NULL);
    if (!dpy) {
        fprintf(stderr, "Unable to open X display\n");
        return 100;
    }

    int screen = DefaultScreen(dpy);
    int x = has_compositor(dpy, screen);
    if (x) {
        printf("A compositor is running on screen %d.\n", screen);
    } else {
        printf("No compositor detected on screen %d.\n", screen);
    }

    XCloseDisplay(dpy);
    return !x; /* 0(has) 1(has not) 100(error) */
}
